import java.io.BufferedReader;
import java.io.FileReader;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.StringTokenizer;
 
/**
 * Created with IntelliJ IDEA.
 * User: poromov
 * Date: 27.11.13
 * Time: 13:56
 * To change this template use File | Settings | File Templates.
 */
public class interactive_bgp {
    public void solve() throws Exception {
        int p = nextInt();
        int v = nextInt();
 
        long[] min = new long[p + 1];
        long[] max = new long[p + 1];
        for (int i = 0; i <= p; i++) {
            min[i] = 0;
            max[i] = v;
        }
 
        long inf = 1000000000;
 
        long moves = 1;
        out.println("check 0 1");
        out.flush();
        nextToken();
 
        while (true) {
            long count = 0;
            for (int i = 0; i <= p; i++) {
                if (min[i] <= max[i]) {
                    long c = max[i] - min[i] + 1;
                    count += c;
                }
            }
 
            if (count == 1) {
                for (int i = 0; i <= p; i++) {
                    if (min[i] <= max[i]) {
                        long value = i + moves * min[i];
                        out.println("answer " + value);
                        out.flush();
                    }
                }
                break;
            }
 
            long left = 0;
            long right = inf;
            while (left < right) {
                long mid = (left + right) / 2;
 
                long up = 0;
                for (int i = 0; i <= p; i++) {
                    if (min[i] > max[i]) {
                        continue;
                    }
                    long from = (mid - i + moves - 1) / moves;
                    if (mid <= i) {
                        from = min[i];
                    }
                    if (from < min[i]) {
                        from = min[i];
                    }
                    if (from <= max[i]) {
                        up += (max[i] - from + 1);
                    }
                }
 
                if (up > count / 2) {
                    left = mid + 1;
                } else {
                    right = mid;
                }
            }
 
            out.println("check " + left + " " + inf);
            //out.println("[" + count + "]");
            out.flush();
            boolean more = nextToken().charAt(0) == 'Y';
 
            for (int i = 0; i <= p; i++) {
                if (min[i] > max[i]) {
                    continue;
                }
 
                if (more) {
                    if (i >= left) {
                        continue;
                    }
 
                    long from = (left - i + moves - 1) / moves;
                    if (from > min[i]) {
                        min[i] = from;
                    }
                } else {
                    if (i >= left) {
                        max[i] = min[i] - 1;
                        continue;
                    }
 
                    long to = (left - i - 1) / moves;
                    if (to < max[i]) {
                        max[i] = to;
                    }
                }
            }
            moves++;
        }
    }
 
    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;
    boolean eof;
 
    int nextInt() {
        return Integer.parseInt(nextToken());
    }
 
    String nextToken() {
        while (st == null || !st.hasMoreTokens()) {
            try {
                st = new StringTokenizer(br.readLine()) ;
            } catch (Exception e) {
                eof = true;
                return "0";
            }
        }
        return st.nextToken();
    }
 
    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
        } catch (Throwable t) {
            t.printStackTrace();
            System.exit(-1);
        } finally {
           out.close();
        }
    }
 
    public static void main(String[] args) {
        new interactive_bgp().run();
    }
}